MODULE FktGraphen;
  FROM InOut     IMPORT WriteInt, Write, WriteString, WriteLn;
  FROM RealInOut IMPORT ReadReal, WriteReal;
  FROM MathLib   IMPORT exp, sin, cos, sqrt;

CONST
  ZeilenLaenge =  60;
  AnzFkt       =   4;

TYPE
  Fkt =  PROCEDURE(REAL) :  REAL;

VAR
  FktFeld     :  ARRAY [0..AnzFkt-1] OF Fkt;
  CharFeld    :  ARRAY [0..AnzFkt-1] OF CHAR;
  ScalingFeld :  ARRAY [0..AnzFkt-1] OF REAL;
  x1, x2      :  REAL;


PROCEDURE Graphen(
  funcArr :  ARRAY OF Fkt;
  charArr :  ARRAY OF CHAR;
  scalArr :  ARRAY OF REAL;
  x1, x2  :  REAL;
  n       :  CARDINAL);

CONST
  zMAX =  79;

VAR
  dx, fmax, fmin, scale, fx, x :  REAL;
  i, j, nr                     :  CARDINAL;
  zeile                        :  ARRAY [1..zMAX] OF CHAR;

BEGIN
  fmin := 0.0;
  fmax := 0.0;
  dx   := (x2 - x1) / FLOAT(n);

  FOR i := 0 TO n DO
    x := x1 + FLOAT(i) * dx;
    FOR nr := 0 TO HIGH(funcArr) DO
      fx   := funcArr[nr](x) * scalArr[nr];
      IF fx < fmin THEN
        fmin := fx
      END;
      IF fx > fmax THEN
        fmax := fx
      END
    END (* FOR nr *)
  END; (* FOR i *)

  WriteReal(fmin, 12);
  WriteReal(fmax, ZeilenLaenge-1-12); WriteLn;
  scale := FLOAT(ZeilenLaenge-1) / (fmax - fmin);

  FOR i := 0 TO n DO
    FOR j := 1 TO ZeilenLaenge - 1 DO
      zeile[j] := ' '
    END;

    x := x1 + FLOAT(i) * dx;
    FOR nr := 0 TO HIGH(funcArr) DO
      zeile[TRUNC((funcArr[nr](x) * scalArr[nr] - fmin) * scale) + 1] := 
         charArr[nr]
    END;

    FOR j := 1 TO ZeilenLaenge - 1 DO
      Write(zeile[j])
    END;
    WriteLn
  END
END Graphen;


PROCEDURE gauss(
  x :  REAL) :  REAL;

CONST
  pi =  3.14159;

BEGIN
  RETURN ( exp(- x * x / 2.0) / sqrt(2.0 * pi) )
END gauss;


BEGIN (* -- Hauptprogramm -- *)
  WriteString("Abschnitt [x1, x2] eingeben "); WriteLn;
  WriteString(" x1 .. "); ReadReal(x1);
  WriteString(" x2 .. "); ReadReal(x2);

  FktFeld[0] := exp;     CharFeld[0] := 'e';   ScalingFeld[0] := 0.1;
  FktFeld[1] := sin;     CharFeld[1] := 's';   ScalingFeld[1] := 2.0;
  FktFeld[2] := cos;     CharFeld[2] := 'c';   ScalingFeld[2] := 2.0;
  FktFeld[3] := gauss;   CharFeld[3] := 'g';   ScalingFeld[3] := 2.0;

  Graphen(FktFeld, CharFeld, ScalingFeld, x1, x2, 22)
END FktGraphen.

