MODULE NormalVerteilung;
  FROM RealInOut IMPORT ReadReal, WriteFloat;
  FROM InOut     IMPORT WriteString, WriteLn, WriteInt;
  FROM MathLib   IMPORT exp, sqrt;

CONST
  pi    = 3.141592653589793238462643383;
  max   = 10;

VAR
  i                             :  INTEGER;
  std, scale, faktor, GaussWert :  REAL;


BEGIN
  WriteString("Berechnung der Normalverteilung ...  ");
  WriteLn;
  WriteString("Eingabe der Standardabweichung: ");
  ReadReal(std); WriteLn;

  scale := 1.0 / (sqrt(2.0 * pi) * std);

  FOR i := -max TO max DO
    faktor    := -(FLOAT(i) * FLOAT(i)) / (2.0 * std);
    GaussWert := scale * exp(faktor);

    WriteInt(i, 5); WriteString(" :  ");
    WriteFloat(GaussWert, 4, 8); WriteLn
  END
END NormalVerteilung.
