MODULE Records;
  FROM InOut IMPORT WriteString, WriteInt, WriteLn;

CONST
  PersAnzahl    =   50;
  FamNameLaenge =   30;
  VorNameLaenge =   50;
  TelLaenge     =   20;
  ZeilLaenge    =   80;
  ErstesJahr    = 1900;
  LetztesJahr   = 2100;

TYPE
  STRING       =  ARRAY [0..ZeilLaenge] OF CHAR;
  MitarbGruppe =  (Prof, AkadRat, WiMi, Sekr, Stud, XXX);
  MONAT        =  (Jan, Feb, Mar, Apr, Mai, Jun, 
                   Jul, Aug, Sep, Okt, Nov, Dez);
  DATUM        =  RECORD
                    tag   :  [1..31];
                    monat :  MONAT;
                    jahr  :  [ErstesJahr..LetztesJahr]
                  END;
  PersDat      =  RECORD
                    PersId      :  MitarbGruppe;
                    FamName     :  ARRAY [0..FamNameLaenge] OF CHAR;
                    VorName     :  ARRAY [0..VorNameLaenge] OF CHAR;
                    EinstDatum  :  DATUM;
                    TelNr       :  ARRAY [0..TelLaenge] OF CHAR;
                    email       :  STRING;
                    Geschlecht  :  (w, m);
                    verheiratet :  BOOLEAN
                  END;

VAR
  k           :  CARDINAL;
  monate      :  MONAT;
  Personen    :  ARRAY [1..PersAnzahl] OF PersDat;
  d           :  DATUM;
  MonatsListe :  ARRAY MONAT OF ARRAY [0..2] OF CHAR;


BEGIN
  FOR k := 1 TO PersAnzahl DO
    Personen[k].PersId := XXX
  END;

  (* -- Personaldaten Eintraege *)
  Personen[1].PersId           := Prof;
  Personen[1].FamName          := "Neumann";
  Personen[1].VorName          := "Heiko";
  Personen[1].EinstDatum.tag   := 4;
  Personen[1].EinstDatum.monat := Okt;
  Personen[1].EinstDatum.jahr  := 1994;
  Personen[1].TelNr            := "(0731) 502-4158";
  Personen[1].email            := "hneumann@neuro.informatik";
  Personen[1].Geschlecht       := m;
  Personen[1].verheiratet      := TRUE;

  (* -- Datum *)
  d.tag   := 1; 
  d.monat := Mai; 
  d.jahr  := 1992; 

  (* -- oder kuerzer mit WITH ... *)
  WITH Personen[2] DO
    PersId      := AkadRat;
    FamName     := "Schwenker";
    VorName     := "Friedhelm";
    EinstDatum  := d;
    TelNr       := "(0731) 502-4159";
    email       := "friedhelm@neuro.informatik";
    Geschlecht  := m;
    verheiratet := TRUE
  END;

  WITH Personen[3] DO
    PersId      := WiMi;
    FamName     := "Kestler";
    VorName     := "Hans";
    WITH EinstDatum DO
      tag   := 1;
      monat := Jun;
      jahr  := 1996
    END;
    TelNr       := "(0731) 502-4157";
    email       := "kestler@neuro.informatik";
    Geschlecht  := m;
    verheiratet := FALSE
  END;

  WITH Personen[4] DO
    PersId      := Sekr;
    FamName     := "Lonsinger-Miller";
    VorName     := "Birgit";
    WITH EinstDatum DO
      tag   := 1;
      monat := Jan;
      jahr  := 1992
    END;
    TelNr       := "(0731) 502-4151";
    email       := "birgit@neuro.informatik";
    Geschlecht  := w;
    verheiratet := TRUE
  END;

  (* Ausgabe ... 
     verschiedene Techniken f. Aufzaehlungstypen 
   *)
  FOR monate := Jan TO Dez DO
    CASE monate OF
      Jan  :  MonatsListe[monate] := "Jan" |
      Feb  :  MonatsListe[monate] := "Feb" |
      Mar  :  MonatsListe[monate] := "Mar" |
      Apr  :  MonatsListe[monate] := "Apr" |
      Mai  :  MonatsListe[monate] := "Mai" |
      Jun  :  MonatsListe[monate] := "Jun" |
      Jul  :  MonatsListe[monate] := "Jul" |
      Aug  :  MonatsListe[monate] := "Aug" |
      Sep  :  MonatsListe[monate] := "Sep" |
      Okt  :  MonatsListe[monate] := "Okt" |
      Nov  :  MonatsListe[monate] := "Nov" |
      Dez  :  MonatsListe[monate] := "Dez"
      ELSE    MonatsListe[monate] := "***"
    END (* CASE *)
  END; (* FOR *)

  k := 1;
  WHILE (Personen[k].PersId <> XXX) AND (k <= PersAnzahl) DO
    WITH Personen[k] DO
      IF Geschlecht = m THEN
        WriteString("Herr ")
      ELSIF Geschlecht = w THEN
        WriteString("Frau ")
      END;
      WriteString(VorName); WriteString(" "); WriteString(FamName); 
      WriteString("("); 
      CASE PersId OF
        Prof    :  WriteString("Prof")    |
        AkadRat :  WriteString("AkadRat") |
        WiMi    :  WriteString("WiMi")    |
        Sekr    :  WriteString("Sekr")    |
        Stud    :  WriteString("Stud")
        ELSE       WriteString("** unbekannte Mitarbeitergruppe ! **")
      END;
      WriteString(")"); 
      IF verheiratet THEN 
        WriteString(", verheiratet")
      ELSE
        WriteString(", ledig")
      END;
      WriteLn;

      WriteString("Einstellungsdatum: ");
      WITH EinstDatum DO
        WriteInt(tag, 3); WriteString(". "); 
        WriteString(MonatsListe[monat]); WriteString(". "); 
        WriteInt(jahr, 5)
      END;
      WriteLn;
      WriteString("Tel. Nr.: "); WriteString(TelNr); WriteLn;
      WriteString("Email   : "); WriteString(email); WriteLn; WriteLn;

      k := k + 1
    END (* WITH *)
  END (* WHILE *)
END Records.
