MODULE SkatSpiel;
  FROM InOut IMPORT WriteString, WriteLn;

TYPE 
  KartenFarbe =  (Kreuz, Pik, Herz, Karo);
  KartenWert  =  (As, Koenig, Dame, Bube, Zehn, Neun, Acht, Sieben);
  Skatkarte   =  RECORD 
                   Farbe : KartenFarbe;
                   Wert  : KartenWert
                 END;

VAR 
  Skatblatt  :  ARRAY[0..31] OF Skatkarte;
  Skat       :  ARRAY[0..1]  OF Skatkarte;
  VH, MH, HH :  ARRAY[0..9] OF Skatkarte;


PROCEDURE Initialisieren;

VAR 
  i     :  CARDINAL;
  wert  :  KartenWert;
  farbe :  KartenFarbe;

BEGIN
  WriteString(".. Initialisieren"); WriteLn;

  i := 0;
  FOR wert := As TO Sieben DO
    FOR farbe := Kreuz TO Karo DO
      Skatblatt[i].Farbe := farbe;
      Skatblatt[i].Wert  := wert;
      i := i + 1 
    END
  END
END Initialisieren;


PROCEDURE Mischen; 

CONST 
  MaxTranspose = 10000;

VAR 
  p1, p2, seed, transpose :  CARDINAL;

PROCEDURE zufall(
  VAR z : CARDINAL) :  CARDINAL;

BEGIN
  z := (125*z) MOD 8192;
  RETURN ((z DIV 4) MOD 32)
END zufall;


PROCEDURE VertauscheKartenImBlatt(
  i, j :  CARDINAL);

VAR 
  karte : Skatkarte;

BEGIN
  karte         := Skatblatt[i];
  Skatblatt[i]  := Skatblatt[j];
  Skatblatt[j]  := karte
END VertauscheKartenImBlatt;


BEGIN
  WriteString(".. Mischen"); WriteLn;

  seed      := 97531; (* einfach mal so *)
  transpose := 0;

  WHILE (transpose <> MaxTranspose) DO
    p1 := zufall(seed);    
    p2 := zufall(seed);
    IF (p1 <> p2) THEN 
      VertauscheKartenImBlatt(p1,p2);
      transpose := transpose + 1
    END
  END
END Mischen;


PROCEDURE Geben;

BEGIN
  WriteString(".. Geben"); WriteLn;
     
  (* jeder 3 *)
  VH[0] := Skatblatt[0];   VH[1] := Skatblatt[1];   VH[2] := Skatblatt[2];
  MH[0] := Skatblatt[3];   MH[1] := Skatblatt[4];   MH[2] := Skatblatt[5];
  HH[0] := Skatblatt[6];   HH[1] := Skatblatt[7];   HH[2] := Skatblatt[8];

  (* Skat *)
  Skat[0] := Skatblatt[9];  Skat[1] := Skatblatt[10];

  (* jeder 4 *)
  VH[3] := Skatblatt[11];   VH[4] := Skatblatt[12];
  VH[5] := Skatblatt[13];   VH[6] := Skatblatt[14];

  MH[3] := Skatblatt[15];   MH[4] := Skatblatt[16];
  MH[5] := Skatblatt[17];   MH[6] := Skatblatt[18];

  HH[3] := Skatblatt[19];   HH[4] := Skatblatt[20];
  HH[5] := Skatblatt[21];   HH[6] := Skatblatt[22];

  (* jeder 3 *)
  VH[7] := Skatblatt[23];   VH[8] := Skatblatt[24];   VH[9] := Skatblatt[25];
  MH[7] := Skatblatt[26];   MH[8] := Skatblatt[27];   MH[9] := Skatblatt[28];
  HH[7] := Skatblatt[29];   HH[8] := Skatblatt[30];   HH[9] := Skatblatt[31];
END Geben;


PROCEDURE KarteDrucken(
  karte :  Skatkarte);

BEGIN
  CASE karte.Wert OF
    As     :  WriteString("As     ") |
    Koenig :  WriteString("Koenig ") |
    Dame   :  WriteString("Dame   ") |
    Bube   :  WriteString("Bube   ") |
    Zehn   :  WriteString("Zehn   ") |
    Neun   :  WriteString("Neun   ") |
    Acht   :  WriteString("Acht   ") |
    Sieben :  WriteString("Sieben ")
    ELSE      WriteString("ungueltiger Kartenwert")
  END; 

  CASE karte.Farbe OF
    Kreuz :  WriteString("Kreuz ") |
    Pik   :  WriteString("Pik   ") |
    Herz  :  WriteString("Herz  ") |
    Karo  :  WriteString("Karo  ")
    ELSE     WriteString("ungueltige Kartenfarbe")
  END; 
  WriteLn
END KarteDrucken;


PROCEDURE Drucken(
  blatt :  ARRAY OF Skatkarte);

VAR 
  i :  CARDINAL;

BEGIN   
  FOR i := 0 TO HIGH(blatt) DO
    KarteDrucken(blatt[i])
  END
END Drucken;


PROCEDURE SortiertDrucken(
  blatt :  ARRAY OF Skatkarte);

VAR 
  wert  :  KartenWert;
  farbe :  KartenFarbe;
  karte :  Skatkarte;
              

PROCEDURE KarteGefunden(
  karte :  Skatkarte; 
  blatt :  ARRAY OF Skatkarte) :  BOOLEAN;

VAR 
  i        :  CARDINAL;
  gefunden :  BOOLEAN;

BEGIN
  i        := 0; 
  gefunden := FALSE;  
  WHILE (i <= HIGH(blatt)) AND (NOT gefunden) DO
    IF (blatt[i].Farbe = karte.Farbe) AND 
       (blatt[i].Wert  = karte.Wert) THEN
      gefunden := TRUE
    ELSE
      i := i + 1    
    END
  END;
  RETURN gefunden
END KarteGefunden;

BEGIN
  FOR wert := As TO Sieben DO
    FOR farbe := Kreuz TO Karo DO
      karte.Farbe := farbe;
      karte.Wert  := wert;
      IF KarteGefunden(karte,blatt) THEN
        KarteDrucken(karte)           
      END
    END
  END
END SortiertDrucken;

BEGIN (* -- Hauptprogramm -- *)
  WriteString("Skatspiel"); WriteLn;

  Initialisieren;
  Drucken(Skatblatt);
  Mischen;
  Drucken(Skatblatt);
  Geben;


  WriteString(".. Aufheben (unsortiert)"); WriteLn; 
  WriteString(".. Vorderhand");WriteLn;
  Drucken(VH);

  WriteString(".. Mittelhand");WriteLn;
  Drucken(MH);

  WriteString(".. Hinterhand");WriteLn;
  Drucken(HH);

  WriteString(".. Skat");WriteLn;
  Drucken(Skat);


  WriteString(".. Aufheben (sortiert)"); WriteLn; 
  WriteString(".. Vorderhand");WriteLn;
  SortiertDrucken(VH);

  WriteString(".. Mittelhand");WriteLn;
  SortiertDrucken(MH);

  WriteString(".. Hinterhand");WriteLn;
  SortiertDrucken(HH);

  WriteString(".. Skat");WriteLn;
  SortiertDrucken(Skat);

  WriteString("Ende"); WriteLn
END SkatSpiel.

