MODULE SucheMuster;
   FROM ASCII   IMPORT nl;
   FROM InOut   IMPORT ReadString, WriteInt, WriteLn, WriteString, Write, Read;
   FROM FtdIO   IMPORT Done, FreadChar;
   FROM StdIO   IMPORT stdin, read, FILE, Fopen, Fclose;
   FROM Strings IMPORT StrLen;

   CONST 
      maxLENGTH   =  100000;
      notInString =  -1;

   TYPE 
      string =  ARRAY [1..maxLENGTH] OF CHAR;

   VAR 
      filename, text, pattern :  string;
      index                   :  INTEGER;
      file                    :  FILE;
      result                  :  BOOLEAN;
      ch                      :  CHAR;

   PROCEDURE ReadLine(
          file :  FILE; 
      VAR s    :  ARRAY OF CHAR) :  BOOLEAN;
   VAR 
      i  :  INTEGER;
      ch :  CHAR;

   BEGIN 
      i :=  0;
      FreadChar(file, ch);
      WHILE Done & (ch <> nl) & (i < INTEGER(HIGH(s))) DO 
         s[i] :=  ch;
         INC(i);
         FreadChar(file, ch)
      END;

      s[i] :=  0C;
      IF Done & (ch = nl) THEN 
         RETURN TRUE
      ELSE 
         RETURN FALSE
      END
   END ReadLine;

   PROCEDURE ReadText(
      file  :  FILE; 
      VAR s :  ARRAY OF CHAR) :  BOOLEAN;
   VAR 
      i : INTEGER;
      ch: CHAR;

   BEGIN 
      i := 0;
      FreadChar(file, ch);
      WHILE Done & (i < INTEGER(HIGH(s))) DO 
         s[i] := ch;
         INC(i);
         FreadChar(file, ch)
      END;

      s[i] :=  0C;
      IF ~Done THEN 
         RETURN TRUE
      ELSE 
         RETURN FALSE
      END
   END ReadText;

   PROCEDURE MatchSimple( 
          s :        string; 
          pattern :  ARRAY OF CHAR; 
      VAR index   :  INTEGER);

   VAR 
      plen, ppos, spos : INTEGER;

   BEGIN 
      index :=  notInString;

      plen :=  StrLen(pattern);
      IF ( plen > 0 ) THEN 
         spos :=  1;
         ppos :=  0;
         WHILE ( pattern[ppos] <> 0C ) & ( s[spos] <> 0C ) DO 
            IF ( s[spos] = pattern[ppos]) THEN 
               spos :=  spos + 1;
               ppos :=  ppos + 1
            ELSE 
               spos :=  spos - ppos + 1;
               ppos :=  0
            END;
         END;

         IF ( pattern[ppos] = 0C ) THEN 
            index :=  spos - plen
         ELSE 
            index :=  notInString
         END
      END 
   END MatchSimple;

BEGIN (* -- Hauptprogramm "SucheMuster" -- *)
   WriteString("Bitte den Namen der zu durchsuchenden Datei eingeben :  ");
   ReadString(filename);

   IF Fopen(file, filename, read, TRUE) THEN
      IF ReadText(file, text) THEN 

         WriteString("Bitte Suchmuster eingeben :  ");
         IF ReadLine(stdin, pattern) THEN 

            MatchSimple(text, pattern, index);

            IF index = notInString THEN
               WriteString("*** Muster nicht gefunden ! ***");
               WriteLn
            ELSE
               WriteString("Muster an Position ");
               WriteInt(index, 0);
               WriteString(" im Text gefunden !");
               WriteLn
            END
         ELSE 
            WriteString("*** Fehler: konnte Muster nicht lesen ! ***");
            WriteLn
         END
      ELSE 
         WriteString("*** Fehler: konnte Text nicht lesen ! ***");
         WriteLn
      END;

      result := Fclose(file);
   ELSE
      WriteString("*** Fehler: konnte Datei nicht oeffnen ! ***");
      WriteLn
   END
END SucheMuster. 
