MODULE Zaubertrank;
  FROM InOut IMPORT WriteString, WriteInt, WriteLn;

(*
 * -- Beispielprogramm zur Veranschaulichung von Parameteruebergabe-
 * -- Mechanismen und Sichtbarkeitsregeln (Blockstruktur)
 *)

VAR
  Idefix, Asterix, Obelix,
  Majestix, Miraculix, Troubadix :  INTEGER;

(* -- Nonsens:   Block-Ebene 1 *)
PROCEDURE Nonsens(
  VAR Asterix :  INTEGER;
  Obelix      :  INTEGER);

VAR
  Idefix :  INTEGER;

(* -- Nonsens2:  Block-Ebene 2 *)
PROCEDURE Nonsens2(
  VAR Asterix, Grautvornix :  INTEGER;
  Obelix                   :  INTEGER);

VAR
  Idefix :  INTEGER;

BEGIN
  Grautvornix := Asterix + Obelix;
  Asterix     := Asterix + Grautvornix;
  Idefix      := Asterix + Majestix;
  Obelix      := Idefix  + Idefix
END Nonsens2; (* Block-Ebene 2 *)

BEGIN
  Idefix  := Asterix + Obelix;
  Nonsens2(Asterix, Idefix, Troubadix);
  Obelix  := Idefix  + Idefix;
  Asterix := Asterix + Obelix;
  Nonsens2(Miraculix, Miraculix, Troubadix)
END Nonsens; (*  Block-Ebene 1 *)

PROCEDURE DruckeVariablen;
BEGIN
  WriteString("| "); WriteInt(Idefix,    6); WriteString(" | "); 
                     WriteInt(Asterix,   7); WriteString(" | ");
                     WriteInt(Obelix,    7); WriteString(" | ");
                     WriteInt(Majestix,  8); WriteString(" | ");
                     WriteInt(Miraculix, 9); WriteString(" | ");
                     WriteInt(Troubadix, 9); WriteString(" |"); WriteLn
END DruckeVariablen;

BEGIN (* -- Zaubertrank -- *)
  Idefix    :=      1;
  Asterix   :=     10;
  Obelix    :=    100;
  Majestix  :=   1000;
  Miraculix :=  10000;
  Troubadix := 100000;

  WriteString("+===============================================================+"); WriteLn;
  WriteString("| Idefix | Asterix |  Obelix | Majestix | Miraculix | Troubadix |"); WriteLn;
  WriteString("|===============================================================|"); WriteLn;
  DruckeVariablen;

  Nonsens(Obelix, Asterix);
  DruckeVariablen;

  Nonsens(Obelix, Obelix);
  DruckeVariablen;

  Nonsens(Idefix, Idefix);
  DruckeVariablen;

  WriteString("+===============================================================+"); WriteLn
END Zaubertrank.
